moDraw.animals = {};

function moDraw.animals:setOpenPDA(self)	
	--local animals = g_currentMission.husbandries;
	if tonumber(moDefault.animalsObjects) == 0 then
		moGuiMiniPDAsetGet.slotOpen = 0;
		g_currentMission:showBlinkingWarning(unpack(moLanguage.extern['animalsNO'.. moDefault.language]), 3000);
		return;
	end;
	local openSwitchStatus = moGuiMiniPDAsetGet.slotSwitch[moGuiMiniPDAsetGet.slotOpen];
	setTextBold(true);
	local fixDifferenz = 0.007+moSetGetGui.pdaMenueSize/2;
	local posBanimals = moSetGetGui.pdaMenueSize/3*(37+moSetGetGui.screenAspectRatio)*1.03;
	local posX = moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen]+(moSetGetGui.pdaMenueSize*2/1.8);
	if moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen] > 0.5 then posX = moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen]+(moSetGetGui.pdaMenueSize*2/1.8)-(posBanimals);end;
	local posY = moGuiMiniPDAsetGet.slotOpenY[moGuiMiniPDAsetGet.slotOpen];
	local posH = moSetGetGui.pdaMenuePosHeight;
	local firstPosXY = posY-(moSetGetGui.pdaMenueSize/1.17);
	local firstPosXYsave = posY-(moSetGetGui.pdaMenueSize/1.17);
	local lengthAllAnimals = 0;
	local firstLetter = 0.003;
	function nextLine(posNew, setLine)
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-moSetGetGui.pdaMenueLineDif, firstPosXY-moSetGetGui.pdaMenueLineDif-0.002, posBanimals-fixDifferenz, 0.001);
			moSetGetGui["designLine"]:render();
		end;
		firstPosXY = firstPosXY-(moSetGetGui.pdaMenueSize+posNew);
		posH = posH+moSetGetGui.pdaMenueSize+posNew;
		posY = posY-(moSetGetGui.pdaMenueSize+posNew);
	end;
	moSetGetGui["designGround"]:render();
	setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));			
	renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['animals'.. moDefault.language]));	
	nextLine(0.005, true);
	function setInternProductivity(animalName, animal, ls)
		setTextBold(true);
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		if not ls then
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, "*".. moAnimals[animal].typeName.. "*".. moAnimals[animal].animalType)
		else
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, "*".. moAnimals[animal].typeName.. "*")
		end;		
		setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
		setTextAlignment(RenderText.ALIGN_RIGHT);
		renderText(posX+(posBanimals/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moAnimals[animal].num);				
		setTextAlignment(false);
		setTextBold(false);
		if not ls and moDefault.viehmarkt and moShopMods["viehmarkt"] ~= nil then						
			for k, v in pairs(moShopMods["viehmarkt"].descName) do
				if tostring(v) == tostring(animalName) then
					nextLine(0.0015);
					setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
					renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, "(".. moShopMods["viehmarkt"].station.. " ".. tonumber(moShopMods["viehmarkt"].price[k]).. "€)");
					break;
				end;
			end;			
		end;
		nextLine(0.0015);						
		setTextColor(unpack(moAnimals[animal].productivityColor));
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['productivity'.. moDefault.language]));				
		setTextAlignment(RenderText.ALIGN_RIGHT);				
		renderText(posX+(posBanimals/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moAnimals[animal].productivity.. "%");
		setTextAlignment(false);				
	end;			
	function setAnimalsBuy(animal)
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['pigBuy'.. moDefault.language]));
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moAnimals[animal].numBuyColor));
		renderText(posX+(posBanimals/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moAnimals[animal].numBuy);	
		setTextAlignment(false);
	end;			
	function setInternBedarf(txt, what)
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, txt);				
		setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
		setTextAlignment(RenderText.ALIGN_RIGHT);
		renderText(posX+(posBanimals/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, what);
		setTextAlignment(false);
	end;
	function setLsAnimals(animal)
		lengthAllAnimals = lengthAllAnimals+tonumber(moAnimals[animal].num);
		local animalName = moAnimals[animal].animalName;
		setInternProductivity(animalName, animal, true);
		nextLine(0.0015);
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		if tostring(animalName) == "chicken" then
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moAnimalsTXT.pickupName);				
			setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX+(posBanimals/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moAnimals[animal].amount);
			setTextAlignment(false);
			--if tonumber(openSwitchStatus) ~= 4 then
				nextLine(0.005);
				setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
				renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moAnimalsTXT.eggName);				
				setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
				setTextAlignment(RenderText.ALIGN_RIGHT);				
				setTextColor(unpack(moAnimals[animal].pickupEggColor));
				renderText(posX+(posBanimals/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moAnimals[animal].pickupEgg);
				setTextAlignment(false);		
				if moDefault.watermod then
					nextLine(0.0015);					
					setInternBedarf(moAnimalsTXT.wheat, moAnimals[animal].wheatFillLevel);
					nextLine(0.0015);					
					setInternBedarf(moAnimalsTXT.water, moAnimals[animal].waterFillLevel);
				end;
			--end;
			nextLine(0.005, true);
			setTextAlignment(false);
		end;
		if tostring(animalName) == "sheep" then
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moAnimalsTXT.woolName);				
			setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
			setTextAlignment(RenderText.ALIGN_RIGHT);
			local amountWool = moAnimals[animal].amountWool;
			--local woolPro = "(".. string.format("%1.0f", "".. tonumber(amountWool)/tonumber(moAnimals[animal].palCapacity*100)).. "%)";
			local woolPro = "(".. string.format("%1.0f", "".. moAnimals[animal].woolProzent).. "%)";
			setTextColor(unpack(moAnimals[animal].amountWoolColor));				
			renderText(posX+(posBanimals/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, amountWool.. woolPro);				
			setTextAlignment(false);
			if moAnimals[animal].maxPal ~= nil and moAnimals[animal].fremdObj ~= nil then
				nextLine(0.0015);
				setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
				if moAnimals[animal].fremdObj then setTextColor(unpack(moGuiMiniPDAsetGet.warningColor2));end;
				renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moAnimalsTXT.woolName.. "(Collector)");				
				setTextColor(unpack(moAnimals[animal].palWoolColor));
				setTextAlignment(RenderText.ALIGN_RIGHT);				
				renderText(posX+(posBanimals/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moAnimals[animal].maxPal).. "("..tostring(moAnimals[animal].fillPal).. ")Pal");				
				setTextAlignment(false);
			end;
			--if tonumber(openSwitchStatus) ~= 4 then
				nextLine(0.005);			
				setInternBedarf(moAnimalsTXT.forageMix, moAnimals[animal].forageFillLevel);
				if moDefault.watermod then					
					nextLine(0.0015);
					setInternBedarf(moAnimalsTXT.water, moAnimals[animal].waterFillLevel);			
				end;
			--end;		
			nextLine(0.005, true);
			setTextAlignment(false);
		end;
		if tostring(animalName) == "cow" then
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moAnimalsTXT.milk)
			setTextAlignment(RenderText.ALIGN_RIGHT);
			setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
			renderText(posX+(posBanimals/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moAnimals[animal].amountMilk);	
			setTextAlignment(false);
			if g_currentMission.triggerExtendSellMilk ~= nil or g_currentMission.orgFSsellMilk ~= nil and g_currentMission.orgFSsellMilk then
				nextLine(0.0015);
				setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
				renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['milkBuy'.. moDefault.language]));
				setTextAlignment(RenderText.ALIGN_RIGHT);
				setTextColor(unpack(moAnimals[animal].autoSellMilkColor));
				renderText(posX+(posBanimals/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moAnimals[animal].autoSellMilk);	
				setTextAlignment(false);
			end;
			--if tonumber(openSwitchStatus) ~= 4 then
				nextLine(0.0015);				
				setInternBedarf(moAnimalsTXT.manure, moAnimals[animal].amountManure.. "L");
				nextLine(0.0015);				
				setInternBedarf(moAnimalsTXT.liquidManure, moAnimals[animal].amountLiquidManure.. "L");
				nextLine(0.005);				
				setInternBedarf(moAnimalsTXT.forage, moAnimals[animal].forageFillLevel);
				nextLine(0.0015);				
				setInternBedarf(moAnimalsTXT.silage, moAnimals[animal].silageFillLevel);
				nextLine(0.0015);				
				setInternBedarf(moAnimalsTXT.grass, moAnimals[animal].grassFillLevel);
				nextLine(0.0015);				
				setInternBedarf(moAnimalsTXT.straw, moAnimals[animal].strawFillLevel);
				if moDefault.watermod then
					nextLine(0.0015);					
					setInternBedarf(moAnimalsTXT.water, moAnimals[animal].waterFillLevel);
				end;
			--end;
			nextLine(0.005, true);
			setTextAlignment(false);
		end;
	end;
	function setModAnimals(animal)
		lengthAllAnimals = lengthAllAnimals+tonumber(moAnimals[animal].num);
		local animalName = moAnimals[animal].animalName;
		setInternProductivity(animalName, animal, false);
		nextLine(0.0015);
		setAnimalsBuy(animal);		
		--if tonumber(openSwitchStatus) ~= 4 then
			nextLine(0.0015);				
			setInternBedarf(moAnimalsTXT.manure, moAnimals[animal].amountManure.. "L");		
			nextLine(0.0015);				
			setInternBedarf(moAnimalsTXT.liquidManure, moAnimals[animal].amountLiquidManure.. "L");
			nextLine(0.005);				
			setInternBedarf(moAnimalsTXT.forage, moAnimals[animal].forageFillLevel);
			nextLine(0.0015);				
			setInternBedarf(moAnimalsTXT.grainFruit, moAnimals[animal].grainFruitFillLevel);
			nextLine(0.0015);				
			setInternBedarf(moAnimalsTXT.earthFruit, moAnimals[animal].earthFruitFillLevel);
			nextLine(0.0015);				
			setInternBedarf(moAnimalsTXT.silage, moAnimals[animal].silageFillLevel);
			nextLine(0.0015);				
			setInternBedarf(moAnimalsTXT.water, moAnimals[animal].waterFillLevel);
			nextLine(0.0015);				
			setInternBedarf(moAnimalsTXT.straw, moAnimals[animal].strawFillLevel);		
		--end;
		nextLine(0.005, true);
		setTextAlignment(false);
	end;
	function getAnimalsLength()
		if moDefault.animalsObjects > 4 and tonumber(openSwitchStatus) == 2 then return 5, 8;end;
		if moDefault.animalsObjects > 8 and tonumber(openSwitchStatus) == 3 then return 9, 12;end;
		if moDefault.animalsObjects > 12 and tonumber(openSwitchStatus) == 4 then return 13, 16;end;		
		return 1, 4;
	end;
	local firstAnimalsDisplay, maxAnimalsDisplay = getAnimalsLength();
	local tempAnimalsDisplay = 0;
	--for a=1, moDefault.animalsObjects do
	for k, v in pairs(moAnimals) do
		if moAnimals[k] ~= nil then
			tempAnimalsDisplay = tempAnimalsDisplay+1;
			if tonumber(tempAnimalsDisplay) >= tonumber(firstAnimalsDisplay) then					
				if tonumber(firstAnimalsDisplay) > tonumber(maxAnimalsDisplay) then break;end;
				firstAnimalsDisplay = firstAnimalsDisplay+1;				
				if moAnimals[k].lsTyp and tonumber(moAnimals[k].num) > 0 then --ls animals
					--if tonumber(openSwitchStatus) == 1 or tonumber(openSwitchStatus) == 2 or tonumber(openSwitchStatus) == 4 then
						setLsAnimals(k);
					--end;
				end;
				if not moAnimals[k].lsTyp then
					if tonumber(moAnimals[k].num) > 0 or tonumber(moAnimals[k].numBuy) > 0 then --mod animals
						--if tonumber(openSwitchStatus) == 1 or tonumber(openSwitchStatus) == 3 or tonumber(openSwitchStatus) == 4 then
							setModAnimals(k);
						--end;
					end;
				end;
			end;
		end;
	end;	
	---gesamt
	setTextBold(true);
	setTextAlignment(RenderText.ALIGN_RIGHT);
	setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
	renderText(posX+(posBanimals/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXYsave, moSetGetGui.pdaMenueSize, tostring(lengthAllAnimals));	
	setTextAlignment(false);
	---gesamt
	moSetGetGui:setOverlay(self, moSetGetGui["designGround"], posX-0.003, posY, posBanimals-fixDifferenz+0.003, posH);
	moGuiMiniPDAsetGet.slotOpenLastWidth[moGuiMiniPDAsetGet.slotOpen] = posBanimals-fixDifferenz+0.003;
	moGuiMiniPDAsetGet.slotOpenLastHeight[moGuiMiniPDAsetGet.slotOpen] = posH;	
	setTextBold(false);	
end;