moDraw.placeableTrees = {};

function moDraw.placeableTrees:setOpenPDA(self)	
	if moDefaultUpkPlaceable.lengthTrees == 0 then
		moGuiMiniPDAsetGet.slotOpen = 0;
		g_currentMission:showBlinkingWarning(unpack(moLanguage.extern['placeableTreeNO'.. moDefault.language]), 2500);
		return;
	end;
	setTextBold(true);
	local fixDifferenz = 0.007+moSetGetGui.pdaMenueSize/2;
	local posBplaceableTrees = moSetGetGui.pdaMenueSize/3*(30+moSetGetGui.screenAspectRatio)*1.03;
	local posX = moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen]+(moSetGetGui.pdaMenueSize*2/1.8);
	if moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen] > 0.5 then posX = moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen]+(moSetGetGui.pdaMenueSize*2/1.8)-posBplaceableTrees;end;
	local posY = moGuiMiniPDAsetGet.slotOpenY[moGuiMiniPDAsetGet.slotOpen];
	local posH = moSetGetGui.pdaMenuePosHeight;
	local firstPosXY = posY-(moSetGetGui.pdaMenueSize/1.17);
	local firstLetter = 0.003;
	function nextLine(posNew, setLine)
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-moSetGetGui.pdaMenueLineDif, firstPosXY-moSetGetGui.pdaMenueLineDif-0.002, posBplaceableTrees-fixDifferenz, 0.001);
			moSetGetGui["designLine"]:render();
		end;
		if posNew == 0 then return;end;
		firstPosXY = firstPosXY-(moSetGetGui.pdaMenueSize+posNew);
		posH = posH+moSetGetGui.pdaMenueSize+posNew;
		posY = posY-(moSetGetGui.pdaMenueSize+posNew);
	end;					
	moSetGetGui["designGround"]:render();	
	setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));			
	renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['trees'.. moDefault.language]));
	setTextAlignment(false);
	setTextAlignment(RenderText.ALIGN_RIGHT);
	setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));	
	renderText(posX+(posBplaceableTrees/1.17)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moDefaultUpkPlaceable.lengthTrees));
	setTextAlignment(false);					
	nextLine(0.005, true);
	local splitTrees = Utils.splitString(" ", moDefaultUpkPlaceable.trees)
	for k, v in pairs (splitTrees) do
		if string.len(v) > 1 and v ~= nil and moPlaceableTrees[v] ~= nil then			
			setTextBold(true);
			setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));			
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, "*".. moPlaceableTrees[v].treeName.. "*");
			setTextAlignment(RenderText.ALIGN_RIGHT);
			setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
			renderText(posX+(posBplaceableTrees/1.17)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moPlaceableTrees[v].lengthActive+moPlaceableTrees[v].lengthNotActive));
			setTextAlignment(false);			
			setTextBold(false);			
			if moPlaceableTrees[v].bestPrice > 0 then			
				nextLine(0.0015);
				setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
				renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['price'.. moDefault.language]));
				setTextAlignment(RenderText.ALIGN_RIGHT);
				setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
				local bestPriceTemp = string.format("%.1f", Utils.getNoNil(moPlaceableTrees[v].bestPrice, 0));
				renderText(posX+(posBplaceableTrees/1.17)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(bestPriceTemp).. " €");
				setTextAlignment(false);
				nextLine(0.0025);
			else
				nextLine(0.0025);
			end;						
			setTextColor(unpack(moPlaceableTrees[v].productivityColor));
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['productivity'.. moDefault.language]));
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX+(posBplaceableTrees/1.17)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moPlaceableTrees[v].productivity).. "%");
			setTextAlignment(false);
			nextLine(0.005);
			setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['capacity'.. moDefault.language]));
			setTextAlignment(RenderText.ALIGN_RIGHT);
			setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
			local capacity = string.format("%1.0f", Utils.getNoNil(moPlaceableTrees[v].capacity, 0));
			local fillLevel = string.format("%1.0f", Utils.getNoNil(moPlaceableTrees[v].fillLevel, 0));
			renderText(posX+(posBplaceableTrees/1.17)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(capacity).. " (".. tostring(fillLevel).. ")L");
			setTextAlignment(false);
			nextLine(0.0025);
			local active = false;
			if moPlaceableTrees[v].lengthActive > 0 then
				active = true;
				setTextBold(true);
				setTextColor(unpack(moPlaceableTrees[v].productivityColor));
				renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moPlaceableTrees[v].treeName.. " ^%");
				setTextAlignment(RenderText.ALIGN_RIGHT);
				setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
				renderText(posX+(posBplaceableTrees/1.17)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moPlaceableTrees[v].lengthActive));
				setTextAlignment(false);
				setTextBold(false);
				nextLine(0.0025);
			end;
			if moPlaceableTrees[v].lengthNotActive > 0 then
				setTextColor(unpack(moGuiMiniPDAsetGet.warningColor3));			
				renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, moPlaceableTrees[v].treeName.. " 0%");
				setTextAlignment(RenderText.ALIGN_RIGHT);
				setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
				renderText(posX+(posBplaceableTrees/1.17)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moPlaceableTrees[v].lengthNotActive));
				setTextAlignment(false);
				if not active then nextLine(0.0025);end;
			end;
			nextLine(0.005, true);
		end;
	end;
	moSetGetGui:setOverlay(self, moSetGetGui["designGround"], posX-0.003, posY, posBplaceableTrees-fixDifferenz+0.003, posH);
	moGuiMiniPDAsetGet.slotOpenLastWidth[moGuiMiniPDAsetGet.slotOpen] = posBplaceableTrees-fixDifferenz+0.003;
	moGuiMiniPDAsetGet.slotOpenLastHeight[moGuiMiniPDAsetGet.slotOpen] = posH;	
	setTextBold(false);	
end;