moSetGetPlaceableObjects = {};

function moSetGetPlaceableObjects:setPlaceableObjectsUpdate(self)	
	moDefaultPlaceableObjects.objects = "";
	moDefaultPlaceableObjects.lengthObjects = 0;
	moDefault.warningPlaceableObjectsProductivity = 100;
	moDefault.lengthObjectsFillName = 0;
	moPlaceableObjects = {};	
	function checkPlaceableObjects(xmlModString, name, mapObject, mapObjectFs, a)
		if not mapObject and not mapObjectFs and xmlModString ~= nil then		
			setPlaceableObjects(self, xmlModString, name, mapObject, mapObjectFs, a)				
		end;
		if mapObject and xmlModString ~= nil then setPlaceableObjects(self, xmlModString, name, mapObject, mapObjectFs, a);end;
		if mapObjectFs and xmlModString ~= nil then setPlaceableObjects(self, xmlModString, name, mapObject, mapObjectFs, a);end;
	end;
	for a=1, moDefaultPlaceableObjects.objectsSearch do
		local xmlModString = string.lower(moDefault.gameDir.. moDefaultPlaceableObjects.objectsMod[a]);
		local objectName = moDefaultPlaceableObjects.objectsName[a];
		checkPlaceableObjects(g_currentMission.placeables[xmlModString], objectName, false, false, a);
	end;
	for a=1, moDefaultPlaceableObjects.mapObjectsSearch do
		if moDefaultPlaceableObjects.mapObjectsStatus[a] ~= false then 
			checkPlaceableObjects(moDefaultPlaceableObjects.mapObjectsStatus[a], moDefaultPlaceableObjects.mapObjectsName[a], true, false, a);			
		end;
	end;
	if moDefaultPlaceableObjects.mapObjectsFsSearch > 0 then
		for a=1, moDefaultPlaceableObjects.mapObjectsFsSearch do		 
			checkPlaceableObjects(moDefaultPlaceableObjects.mapObjectsFsStatus[a], moDefaultPlaceableObjects.mapObjectsFsName[a], false, true, a);		
		end;
	end;
	if moDefaultPlaceableObjects.lengthObjects == 0 then
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableObjects ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."placeableObjects ";end;	
	end;	
end;

function setPlaceableObjects(self, xmlModString, objectName, mapObject, mapObjectFs, a)
	moGuiMiniPDAsetGet.slotNotReadyFound = string.gsub(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableObjects ", "");	
	if moPlaceableObjects[objectName] == nil then
		moDefaultPlaceableObjects.lengthObjects = moDefaultPlaceableObjects.lengthObjects+1;
		moPlaceableObjects[objectName] = {};
		moPlaceableObjects[objectName].length = 0;
		moPlaceableObjects[objectName].factoryName = objectName;
		moPlaceableObjects[objectName].mapObject = mapObject;
		moPlaceableObjects[objectName].mapObjectFs = mapObjectFs;
		if mapObjectFs and moLanguage.extern[objectName.. moDefault.language] == nil then			
			moPlaceableObjects[objectName].objectName = "*".. moDefaultPlaceableObjects.mapObjectsFsAttributName[a].. "*";
		else
			moPlaceableObjects[objectName].objectName = unpack(moLanguage.extern[objectName.. moDefault.language]);
		end;		
		moPlaceableObjects[objectName].modName = nil;
		moPlaceableObjects[objectName].fillNames = "";
		moPlaceableObjects[objectName].mixLvl = 0;
		moPlaceableObjects[objectName].capacity = 0;	
		moPlaceableObjects[objectName].fillCapacity = {};
		moPlaceableObjects[objectName].fillLevel = {};		
		moPlaceableObjects[objectName].fillType = {};		
		moPlaceableObjects[objectName].fillTypeName = {};
		moPlaceableObjects[objectName].bestPrice = {};
		moPlaceableObjects[objectName].productivity = 0;
		moPlaceableObjects[objectName].productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
		moPlaceableObjects[objectName].palColor = moGuiMiniPDAsetGet.warningColor0;
	end;	
	local setFirstModName = false;	
	if not mapObject and not mapObjectFs then		
		for k, v in pairs(xmlModString) do			
			moPlaceableObjects[objectName].length = moPlaceableObjects[objectName].length+1
			if not setFirstModName then setFirstModName = true;moPlaceableObjects[objectName].modName = objectName;end;		
			if string.find(objectName, "mischstation") then	setTableMarhu(self, xmlModString[k], objectName);end;			
			if xmlModString[k].FabrikScriptDirtyFlag ~= nil then setTableFabrikScript(self, xmlModString[k], objectName);end;			
		end;
	end;
	setFirstModName = false;
	if mapObject and not mapObjectFs then		
		moPlaceableObjects[objectName].length = moPlaceableObjects[objectName].length+1
		if not setFirstModName then setFirstModName = true;moPlaceableObjects[objectName].modName = objectName;end;
		if string.find(objectName, "mischstation") or string.find(objectName, "ruebenschneider") then setTableMarhu(self, xmlModString, objectName);end;
		if string.find(objectName, "seedmaster2k15") or string.find(objectName, "beetmaster100k") or string.find(objectName, "kompostier_anlage") then setTableMarhu1(self, xmlModString, objectName);end;
	end;
	setFirstModName = false;
	if mapObjectFs and not mapObject then 
		moPlaceableObjects[objectName].length = moPlaceableObjects[objectName].length+1
		if not setFirstModName then setFirstModName = true;moPlaceableObjects[objectName].modName = objectName;end;
		setTableFabrikScript(self, xmlModString, objectName);
	end;	
	if moPlaceableObjects[objectName].modName == nil then table.remove(moPlaceableObjects[objectName]);return;end;
	if not string.find(moDefaultPlaceableObjects.objects, objectName.. " ") then moDefaultPlaceableObjects.objects = moDefaultPlaceableObjects.objects.. objectName.. " ";end;	
end;

function setTableMarhu(self, xmlModString, objectName) --Mischstation,Rübenschneider	
	moPlaceableObjects[objectName].capacity = moPlaceableObjects[objectName].capacity+xmlModString.LvLIndicator.capacity;	
	moPlaceableObjects[objectName].mixLvl = moPlaceableObjects[objectName].mixLvl+xmlModString.MixLvl;	
	local tempCapacity = moPlaceableObjects[objectName].capacity;
	local tempFillLevel = moPlaceableObjects[objectName].mixLvl;		
	if moPlaceableObjects[objectName].fillType[1] == nil then
		table.insert(moPlaceableObjects[objectName].fillCapacity, 1, tempCapacity);
		table.insert(moPlaceableObjects[objectName].fillLevel, 1, tempFillLevel);
		local desc = Fillable.fillTypeIndexToDesc[Fillable.FILLTYPE_FORAGE];
		if desc ~= nil then
			table.insert(moPlaceableObjects[objectName].fillType, 1, false);
			local bestPrice = moFillTypes[desc.index].pricePerLiter*moFillTypes[desc.index].bestPrice*moDefault.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
			table.insert(moPlaceableObjects[objectName].bestPrice, 1, bestPrice);
			local fruitName = moFillTypes[desc.index].fruitName;
			table.insert(moPlaceableObjects[objectName].fillTypeName, 1, fruitName);
		end;
	else
		moPlaceableObjects[objectName].fillCapacity[1] = tempCapacity;
		moPlaceableObjects[objectName].fillLevel[1] = tempFillLevel;
	end;
	for a=1, table.getn(xmlModString.MixTypLvl) do		
		if moPlaceableObjects[objectName].fillCapacity[a+1] == nil then
			moPlaceableObjects[objectName].fillCapacity[a+1] = xmlModString.TipTriggers[a].capacity;
			moPlaceableObjects[objectName].fillLevel[a+1] = xmlModString.MixTypLvl[a];					
			local desc = Fillable.fillTypeIndexToDesc[xmlModString.MixTypName[a].index];
			if desc ~= nil then
				moPlaceableObjects[objectName].fillTypeName[a+1] = moFillTypes[desc.index].fruitName;				
				moPlaceableObjects[objectName].bestPrice[a+1] = 0;
				moPlaceableObjects[objectName].fillType[a+1] = true;				
			else
				moPlaceableObjects[objectName].fillTypeName[a+1] = "unknow";
				moPlaceableObjects[objectName].bestPrice[a+1] = 0;
				moPlaceableObjects[objectName].fillType[a+1] = false;
			end;
		else
			moPlaceableObjects[objectName].fillCapacity[a+1] = moPlaceableObjects[objectName].fillCapacity[a+1]+xmlModString.TipTriggers[a].capacity;				
			moPlaceableObjects[objectName].fillLevel[a+1] = moPlaceableObjects[objectName].fillLevel[a+1]+xmlModString.MixTypLvl[a];				
		end;
	end;
	setProductivityMarhu(self, objectName);	
end;

function setTableFabrikScript(self, xmlModString, objectName)	
	local a = 1;
	for k1,v1 in pairs (xmlModString.Produkte) do
		if moPlaceableObjects[objectName].fillCapacity[a] == nil then
			moPlaceableObjects[objectName].fillCapacity[a] = xmlModString.Produkte[k1].capacity;
			moPlaceableObjects[objectName].fillLevel[a] = xmlModString.Produkte[k1].fillLevel;
			local desc = Fillable.fillTypeIndexToDesc[xmlModString.Produkte[k1].name];
			moPlaceableObjects[objectName].fillType[a] = false;
			if des ~= nil then
				moPlaceableObjects[objectName].fillTypeName[a] = moFillTypes[desc.index].fruitName;
				moPlaceableObjects[objectName].bestPrice[a] = moFillTypes[desc.index].pricePerLiter*moFillTypes[desc.index].bestPrice*moDefault.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
			else
				moPlaceableObjects[objectName].bestPrice[a] = 0;
				local nameLength = string.len(xmlModString.Produkte[k1].nameL)
				if tonumber(nameLength) > 13 and tonumber(moDefault.lengthObjectsFillName) < tonumber(nameLength)-13 then moDefault.lengthObjectsFillName = tonumber(nameLength)-13;end;
				moPlaceableObjects[objectName].fillTypeName[a] = xmlModString.Produkte[k1].nameL
			end;
		else
			moPlaceableObjects[objectName].fillCapacity[a] = moPlaceableObjects[objectName].fillCapacity[a]+xmlModString.Produkte[k1].capacity;
			moPlaceableObjects[objectName].fillLevel[a] = moPlaceableObjects[objectName].fillLevel[a]+xmlModString.Produkte[k1].fillLevel;
		end;
		a = a+1;
	end;	
	for k1,v1 in pairs (xmlModString.Rohstoffe) do
		if moPlaceableObjects[objectName].fillCapacity[a] == nil then
			moPlaceableObjects[objectName].fillCapacity[a] = xmlModString.Rohstoffe[k1].capacity;
			moPlaceableObjects[objectName].fillLevel[a] = xmlModString.Rohstoffe[k1].fillLevel;
			local desc = Fillable.fillTypeIndexToDesc[xmlModString.Rohstoffe[k1].name];
			moPlaceableObjects[objectName].fillType[a] = true;
			if des ~= nil then
				moPlaceableObjects[objectName].fillTypeName[a] = moFillTypes[desc.index].fruitName;
				moPlaceableObjects[objectName].bestPrice[a] = moFillTypes[desc.index].pricePerLiter*moFillTypes[desc.index].bestPrice*moDefault.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
			else
				moPlaceableObjects[objectName].bestPrice[a] = 0;
				local nameLength = string.len(xmlModString.Rohstoffe[k1].nameL)
				if tonumber(nameLength) > 13 and tonumber(moDefault.lengthObjectsFillName) < tonumber(nameLength)-13 then moDefault.lengthObjectsFillName = tonumber(nameLength)-13;end;
				moPlaceableObjects[objectName].fillTypeName[a] = xmlModString.Rohstoffe[k1].nameL
			end;
		else
			moPlaceableObjects[objectName].fillCapacity[a] = moPlaceableObjects[objectName].fillCapacity[a]+xmlModString.Rohstoffe[k1].capacity;
			moPlaceableObjects[objectName].fillLevel[a] = moPlaceableObjects[objectName].fillLevel[a]+xmlModString.Rohstoffe[k1].fillLevel;
		end;
		a = a+1;
	end;
	---palettenSammler	
	local factoryName = moPlaceableObjects[objectName].factoryName;
	if moMapObjects ~= nil and moMapObjects[factoryName.. "PalCollector"] ~= nil then		
		moPlaceableObjects[objectName].fremdObj = false;
		local objCreate = moMapObjects[factoryName.. "PalCollector"].objCreate;		
		moPlaceableObjects[objectName].fillPal = 0;
		local fremdObj = objCreate.fremdObject;
		if fremdObj ~= nil and fremdObj > 0 then moPlaceableObjects[objectName].fremdObj = true;end;
		moPlaceableObjects[objectName].maxPal = table.getn(objCreate.Points);
		local noticePal = 0;
		if moPlaceableObjects[objectName].maxPal ~= nil and moPlaceableObjects[objectName].maxPal > 1 then
			for i = 1, moPlaceableObjects[objectName].maxPal do
				if objCreate.Points[i].Pallet ~= nil then
					noticePal = noticePal+1;					
				end;
			end;
		end;		
		moPlaceableObjects[objectName].fillPal = moPlaceableObjects[objectName].fillPal+noticePal;			
		if moPlaceableObjects[objectName].fillPal >= moPlaceableObjects[objectName].maxPal then moPlaceableObjects[objectName].palColor = moGuiMiniPDAsetGet.warningColor4;end;
		if moPlaceableObjects[objectName].fillPal >= moPlaceableObjects[objectName].maxPal/2 and moPlaceableObjects[objectName].fillPal < moPlaceableObjects[objectName].maxPal then moPlaceableObjects[objectName].palColor = moGuiMiniPDAsetGet.warningColor2;end;
	end;	
	---palettenSammler
	setProductivityMarhu(self, objectName);
end;

function setTableMarhu1(self, xmlModString, objectName) --SeedMaster2k15,BeetMaster100K,Kompostier_Anlage
	local a = 1;	
	if moPlaceableObjects[objectName].fillCapacity[a] == nil then
		moPlaceableObjects[objectName].fillCapacity[a] = xmlModString.TipTrigger.capacity;
		moPlaceableObjects[objectName].fillLevel[a] = xmlModString.SilageLvl;		
		local desc = Fillable.fillTypeIndexToDesc[xmlModString.SilageTrigger.fillType];
		moPlaceableObjects[objectName].fillType[a] = false;
		if des ~= nil then
			moPlaceableObjects[objectName].fillTypeName[a] = moFillTypes[desc.index].fruitName;
			moPlaceableObjects[objectName].bestPrice[a] = moFillTypes[desc.index].pricePerLiter*moFillTypes[desc.index].bestPrice*moDefault.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
		else
			moPlaceableObjects[objectName].bestPrice[a] = 0;
			local fruitName = xmlModString.L_Silage;
			if string.find(xmlModString.L_Silage, "Missing") then
				local splitMissing = Utils.splitString(" ", xmlModString.L_Silage);
				fruitName = "!".. splitMissing[2]
			end;
			local nameLength = string.len(fruitName)
			if tonumber(nameLength) > 13 and tonumber(moDefault.lengthObjectsFillName) < tonumber(nameLength)-13 then moDefault.lengthObjectsFillName = tonumber(nameLength)-13;end;
			moPlaceableObjects[objectName].fillTypeName[a] = fruitName;
		end;
	end;
	a = table.getn(moPlaceableObjects[objectName].fillCapacity)+1;
	if moPlaceableObjects[objectName].fillCapacity[a] == nil then
		moPlaceableObjects[objectName].fillType[a] = true;
		moPlaceableObjects[objectName].bestPrice[a] = 0;
		local fruitNames = "";
		local b = 1;
		for acceptedFillTypes, v in pairs(xmlModString.TipTrigger.acceptedFillTypes) do 
			if v then
				local desc = Fillable.fillTypeIndexToDesc[acceptedFillTypes];
				if desc ~= nil then
					local fruitLsName = moFillTypes[desc.index].fruitName;
					if table.getn(xmlModString.TipTrigger.acceptedFillTypes) == b then
						if moPlaceableObjects[objectName].fillTypeName[1] ~= fruitLsName then
							fruitNames = fruitNames.. fruitLsName;
						end;
					else
						if moPlaceableObjects[objectName].fillTypeName[1] ~= fruitLsName then
							fruitNames = fruitNames.. fruitLsName.. " ";
						end;
					end;					
				end;
			end;
			b = b+1			
		end;
		moPlaceableObjects[objectName].fillNames = fruitNames;
		moPlaceableObjects[objectName].fillTypeName[a] = unpack(moLanguage.extern["fillcontainer".. moDefault.language]);
		moPlaceableObjects[objectName].fillCapacity[a] = xmlModString.TipTrigger.capacity;
		moPlaceableObjects[objectName].fillLevel[a] = xmlModString.FillLvl;
	else
		moPlaceableObjects[objectName].fillCapacity[a] = moPlaceableObjects[objectName].fillCapacity[a]+xmlModString.TipTrigger.capacity;
		moPlaceableObjects[objectName].fillLevel[a] = moPlaceableObjects[objectName].fillLevel[a]+xmlModString.FillLvl;
	end;
	setProductivityMarhu(self, objectName);
end;

function setProductivityMarhu(self, objectName)
	local noProductivity = false;
	local capacityFull = false;	
	for a=1, table.getn(moPlaceableObjects[objectName].fillCapacity) do
		local fillLevel = moPlaceableObjects[objectName].fillLevel[a];
		if not moPlaceableObjects[objectName].fillType[a] then --if tonumber(a) == 1 then
			if tonumber(fillLevel) >= tonumber(moPlaceableObjects[objectName].fillCapacity[a]) then
				moPlaceableObjects[objectName].productivityColor = moGuiMiniPDAsetGet.warningColor2; --moGuiExtras.colors['yellow'];
				moPlaceableObjects[objectName].productivity = string.format("%0.0f", Utils.getNoNil(0, 0));
				capacityFull = true;
			end;
		end;
		if moPlaceableObjects[objectName].fillType[a] and tonumber(fillLevel) == 0 then --tonumber(a) > 1 and tonumber(fillLevel) == 0 then 
			moPlaceableObjects[objectName].productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
			moPlaceableObjects[objectName].productivity = string.format("%0.0f", Utils.getNoNil(0, 0));
			noProductivity = true;
			break;
		end;
	end;	
	if not capacityFull and not noProductivity then
		moPlaceableObjects[objectName].productivityColor = moGuiMiniPDAsetGet.warningColor0; --moGuiExtras.colors['green'];
		moPlaceableObjects[objectName].productivity = string.format("%0.0f", Utils.getNoNil(100, 0));
	end;	
	if tonumber(moDefault.warningPlaceableObjectsProductivity) >= tonumber(moPlaceableObjects[objectName].productivity) then 
		moDefault.warningPlaceableObjectsProductivity = tonumber(moPlaceableObjects[objectName].productivity);	
	end;
end;